<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBuddyType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBuddyType
 * @subpackage Arrays
 */
class ArrayOfBuddyType extends AbstractStructArrayBase
{
    /**
     * The BuddyType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BuddyType[]
     */
    public $BuddyType;
    /**
     * Constructor method for ArrayOfBuddyType
     * @uses ArrayOfBuddyType::setBuddyType()
     * @param \StructType\BuddyType[] $buddyType
     */
    public function __construct(array $buddyType = array())
    {
        $this
            ->setBuddyType($buddyType);
    }
    /**
     * Get BuddyType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BuddyType[]|null
     */
    public function getBuddyType()
    {
        return isset($this->BuddyType) ? $this->BuddyType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBuddyType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBuddyType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBuddyTypeForArrayConstraintsFromSetBuddyType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBuddyTypeBuddyTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfBuddyTypeBuddyTypeItem instanceof \StructType\BuddyType) {
                $invalidValues[] = is_object($arrayOfBuddyTypeBuddyTypeItem) ? get_class($arrayOfBuddyTypeBuddyTypeItem) : sprintf('%s(%s)', gettype($arrayOfBuddyTypeBuddyTypeItem), var_export($arrayOfBuddyTypeBuddyTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BuddyType property can only contain items of type \StructType\BuddyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BuddyType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BuddyType[] $buddyType
     * @return \ArrayType\ArrayOfBuddyType
     */
    public function setBuddyType(array $buddyType = array())
    {
        // validation for constraint: array
        if ('' !== ($buddyTypeArrayErrorMessage = self::validateBuddyTypeForArrayConstraintsFromSetBuddyType($buddyType))) {
            throw new \InvalidArgumentException($buddyTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($buddyType) || (is_array($buddyType) && empty($buddyType))) {
            unset($this->BuddyType);
        } else {
            $this->BuddyType = $buddyType;
        }
        return $this;
    }
    /**
     * Add item to BuddyType value
     * @throws \InvalidArgumentException
     * @param \StructType\BuddyType $item
     * @return \ArrayType\ArrayOfBuddyType
     */
    public function addToBuddyType(\StructType\BuddyType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BuddyType) {
            throw new \InvalidArgumentException(sprintf('The BuddyType property can only contain items of type \StructType\BuddyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BuddyType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BuddyType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BuddyType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BuddyType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BuddyType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BuddyType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BuddyType
     */
    public function getAttributeName()
    {
        return 'BuddyType';
    }
}
