<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetrievePNRBookingAgent' => '\\StructType\\RetrievePNRBookingAgent',
            'RetrievePNRBookingAgentResponse' => '\\StructType\\RetrievePNRBookingAgentResponse',
            'UpdateExternalBookingReference' => '\\StructType\\UpdateExternalBookingReference',
            'UpdateExternalBookingReferenceResponse' => '\\StructType\\UpdateExternalBookingReferenceResponse',
            'RetrieveSystemOptionValue' => '\\StructType\\RetrieveSystemOptionValue',
            'RetrieveSystemOptionValueResponse' => '\\StructType\\RetrieveSystemOptionValueResponse',
            'ClearServiceCache' => '\\StructType\\ClearServiceCache',
            'ClearServiceCacheResponse' => '\\StructType\\ClearServiceCacheResponse',
            'RetrieveHtmlReciept' => '\\StructType\\RetrieveHtmlReciept',
            'RetrieveHtmlRecieptResponse' => '\\StructType\\RetrieveHtmlRecieptResponse',
            'RetrieveServiceInformation' => '\\StructType\\RetrieveServiceInformation',
            'RetrieveServiceInformationResponse' => '\\StructType\\RetrieveServiceInformationResponse',
            'RetrieveBuddyListTypes' => '\\StructType\\RetrieveBuddyListTypes',
            'RetrieveBuddyListTypesResponse' => '\\StructType\\RetrieveBuddyListTypesResponse',
            'ArrayOfBookingReference' => '\\ArrayType\\ArrayOfBookingReference',
            'BookingReference' => '\\StructType\\BookingReference',
            'RetrieveHtmlReceipt' => '\\StructType\\RetrieveHtmlReceipt',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'ReservationInfo' => '\\StructType\\ReservationInfo',
            'ViewPNRBookingAgent' => '\\StructType\\ViewPNRBookingAgent',
            'ViewSystemOptionValue' => '\\StructType\\ViewSystemOptionValue',
            'ViewHtmlReceipt' => '\\StructType\\ViewHtmlReceipt',
            'ViewServiceInformations' => '\\StructType\\ViewServiceInformations',
            'ArrayOfViewServiceInformation' => '\\ArrayType\\ArrayOfViewServiceInformation',
            'ViewServiceInformation' => '\\StructType\\ViewServiceInformation',
            'ViewBuddyListTypes' => '\\StructType\\ViewBuddyListTypes',
            'ArrayOfBuddyType' => '\\ArrayType\\ArrayOfBuddyType',
            'BuddyType' => '\\StructType\\BuddyType',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'ViewPNR' => '\\StructType\\ViewPNR',
            'ArrayOfAirline' => '\\ArrayType\\ArrayOfAirline',
            'Airline' => '\\StructType\\Airline',
            'ArrayOfLogicalFlight' => '\\ArrayType\\ArrayOfLogicalFlight',
            'LogicalFlight' => '\\StructType\\LogicalFlight',
            'ArrayOfPhysicalFlight' => '\\ArrayType\\ArrayOfPhysicalFlight',
            'PhysicalFlight' => '\\StructType\\PhysicalFlight',
            'ArrayOfCustomer' => '\\ArrayType\\ArrayOfCustomer',
            'Customer' => '\\StructType\\Customer',
            'ArrayOfAirlinePerson' => '\\ArrayType\\ArrayOfAirlinePerson',
            'AirlinePerson' => '\\StructType\\AirlinePerson',
            'Person' => '\\StructType\\Person',
            'ArrayOfSeatAssignment' => '\\ArrayType\\ArrayOfSeatAssignment',
            'SeatAssignment' => '\\StructType\\SeatAssignment',
            'ArrayOfSeatAttribute' => '\\ArrayType\\ArrayOfSeatAttribute',
            'SeatAttribute' => '\\StructType\\SeatAttribute',
            'ArrayOfCharge' => '\\ArrayType\\ArrayOfCharge',
            'Charge' => '\\StructType\\Charge',
            'ArrayOfReservationPaymentMap' => '\\ArrayType\\ArrayOfReservationPaymentMap',
            'ReservationPaymentMap' => '\\StructType\\ReservationPaymentMap',
            'ArrayOfBaggage' => '\\ArrayType\\ArrayOfBaggage',
            'Baggage' => '\\StructType\\Baggage',
            'ArrayOfOAFlight' => '\\ArrayType\\ArrayOfOAFlight',
            'OAFlight' => '\\StructType\\OAFlight',
            'ArrayOfOAFlightPerson' => '\\ArrayType\\ArrayOfOAFlightPerson',
            'OAFlightPerson' => '\\StructType\\OAFlightPerson',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'Payment' => '\\StructType\\Payment',
            'ArrayOfHistory' => '\\ArrayType\\ArrayOfHistory',
            'History' => '\\StructType\\History',
            'ArrayOfComment' => '\\ArrayType\\ArrayOfComment',
            'Comment' => '\\StructType\\Comment',
            'ArrayOfGDSHistory' => '\\ArrayType\\ArrayOfGDSHistory',
            'GDSHistory' => '\\StructType\\GDSHistory',
            'ArrayOfReservationContact' => '\\ArrayType\\ArrayOfReservationContact',
            'ReservationContact' => '\\StructType\\ReservationContact',
            'ArrayOfContactInfo' => '\\ArrayType\\ArrayOfContactInfo',
            'ContactInfo' => '\\StructType\\ContactInfo',
            'ArrayOfVoucher' => '\\ArrayType\\ArrayOfVoucher',
            'Voucher' => '\\StructType\\Voucher',
            'ArrayOfCar' => '\\ArrayType\\ArrayOfCar',
            'Car' => '\\StructType\\Car',
            'ArrayOfHotel' => '\\ArrayType\\ArrayOfHotel',
            'Hotel' => '\\StructType\\Hotel',
            'ArrayOfPackage' => '\\ArrayType\\ArrayOfPackage',
            'Package' => '\\StructType\\Package',
            'ArrayOfPaymentMetaData' => '\\ArrayType\\ArrayOfPaymentMetaData',
            'PaymentMetaData' => '\\StructType\\PaymentMetaData',
        );
    }
}
