<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViewHtmlReceipt StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ViewHtmlReceipt
 * @subpackage Structs
 */
class ViewHtmlReceipt extends AbstractStructBase
{
    /**
     * The HtmlReceipt
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $HtmlReceipt;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for ViewHtmlReceipt
     * @uses ViewHtmlReceipt::setHtmlReceipt()
     * @uses ViewHtmlReceipt::setExceptions()
     * @param string $htmlReceipt
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct($htmlReceipt = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setHtmlReceipt($htmlReceipt)
            ->setExceptions($exceptions);
    }
    /**
     * Get HtmlReceipt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHtmlReceipt()
    {
        return isset($this->HtmlReceipt) ? $this->HtmlReceipt : null;
    }
    /**
     * Set HtmlReceipt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $htmlReceipt
     * @return \StructType\ViewHtmlReceipt
     */
    public function setHtmlReceipt($htmlReceipt = null)
    {
        // validation for constraint: string
        if (!is_null($htmlReceipt) && !is_string($htmlReceipt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($htmlReceipt, true), gettype($htmlReceipt)), __LINE__);
        }
        if (is_null($htmlReceipt) || (is_array($htmlReceipt) && empty($htmlReceipt))) {
            unset($this->HtmlReceipt);
        } else {
            $this->HtmlReceipt = $htmlReceipt;
        }
        return $this;
    }
    /**
     * Get Exceptions value
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return $this->Exceptions;
    }
    /**
     * Set Exceptions value
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\ViewHtmlReceipt
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this->Exceptions = $exceptions;
        return $this;
    }
}
