<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViewServiceInformations StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ViewServiceInformations
 * @subpackage Structs
 */
class ViewServiceInformations extends AbstractStructBase
{
    /**
     * The ServiceInformations
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfViewServiceInformation
     */
    public $ServiceInformations;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for ViewServiceInformations
     * @uses ViewServiceInformations::setServiceInformations()
     * @uses ViewServiceInformations::setExceptions()
     * @param \ArrayType\ArrayOfViewServiceInformation $serviceInformations
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct(\ArrayType\ArrayOfViewServiceInformation $serviceInformations = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setServiceInformations($serviceInformations)
            ->setExceptions($exceptions);
    }
    /**
     * Get ServiceInformations value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfViewServiceInformation|null
     */
    public function getServiceInformations()
    {
        return isset($this->ServiceInformations) ? $this->ServiceInformations : null;
    }
    /**
     * Set ServiceInformations value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfViewServiceInformation $serviceInformations
     * @return \StructType\ViewServiceInformations
     */
    public function setServiceInformations(\ArrayType\ArrayOfViewServiceInformation $serviceInformations = null)
    {
        if (is_null($serviceInformations) || (is_array($serviceInformations) && empty($serviceInformations))) {
            unset($this->ServiceInformations);
        } else {
            $this->ServiceInformations = $serviceInformations;
        }
        return $this;
    }
    /**
     * Get Exceptions value
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return $this->Exceptions;
    }
    /**
     * Set Exceptions value
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\ViewServiceInformations
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this->Exceptions = $exceptions;
        return $this;
    }
}
